var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import * as fs from 'fs-extra';
import * as path from 'path';
import debug from 'debug';
import uniqid from 'uniqid';
export var CacheStatus;
(function (CacheStatus) {
    CacheStatus[CacheStatus["MISS"] = 0] = "MISS";
    CacheStatus[CacheStatus["PENDING"] = 1] = "PENDING";
    CacheStatus[CacheStatus["HIT"] = 2] = "HIT";
})(CacheStatus || (CacheStatus = {}));
var SsgCache = (function () {
    function SsgCache() {
        this.maxTimeout = 60000;
        this.debugInstance = debug('next-ssg-cache');
        var hasBuildId = fs.existsSync(SsgCache.BUILD_ID_PATH);
        var buildId = !hasBuildId ? uniqid() : fs.readFileSync(SsgCache.BUILD_ID_PATH, {
            encoding: 'utf-8',
        });
        if (!buildId) {
            throw new Error('Empty build ID');
        }
        try {
            if (!hasBuildId) {
                if (!fs.existsSync(SsgCache.CACHE_DIR)) {
                    fs.mkdirSync(SsgCache.CACHE_DIR, { recursive: true });
                }
                fs.writeFileSync(SsgCache.BUILD_ID_PATH, buildId);
            }
            this.persistent = true;
        }
        catch (err) {
            this.debugInstance("Unable to write build ID: (%O)", err);
            this.persistent = false;
        }
        this.id = buildId;
        if (this.persistent) {
            var path_1 = this.path();
            try {
                if (!fs.existsSync(path_1)) {
                    fs.mkdirSync(path_1, {
                        recursive: true,
                    });
                }
            }
            catch (err) {
                console.warn('[next-ssg-cache] Running in memory-only mode');
                this.debugInstance("Unable to create cache directory, running in memory-only mode: (%O)", err);
                this.persistent = false;
            }
        }
        else {
            console.warn('[next-ssg-cache] Running in memory-only mode');
        }
    }
    SsgCache.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var id;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!fs.existsSync(SsgCache.CACHE_DIR)) return [3, 2];
                        return [4, fs.mkdir(SsgCache.CACHE_DIR, {
                                recursive: true,
                            })];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        id = uniqid();
                        return [4, fs.writeFile(SsgCache.BUILD_ID_PATH, id)];
                    case 3:
                        _a.sent();
                        return [2, id];
                }
            });
        });
    };
    SsgCache.prototype.path = function (keys, ext) {
        if (keys === void 0) { keys = []; }
        var resolved = keys.length
            ? path.resolve(SsgCache.BUILD_CACHE_PATH, this.id, keys.join('-').replace(/\//g, '-'))
            : path.resolve(SsgCache.BUILD_CACHE_PATH, this.id);
        return ext ? "".concat(resolved, ".").concat(ext) : resolved;
    };
    SsgCache.prototype.writeCacheStatus = function (keys, status) {
        return __awaiter(this, void 0, void 0, function () {
            var statPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        statPath = this.path(keys, 'stat');
                        if (!this.persistent) return [3, 2];
                        return [4, fs.writeFile(statPath, String(status), {
                                encoding: 'utf-8',
                            })];
                    case 1:
                        _a.sent();
                        return [3, 3];
                    case 2:
                        SsgCache.cacheStatus[statPath] = status;
                        _a.label = 3;
                    case 3: return [2];
                }
            });
        });
    };
    SsgCache.prototype.readCacheStatus = function (keys) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var statPath, status_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        statPath = this.path(keys, 'stat');
                        if (!this.persistent) return [3, 3];
                        if (!fs.existsSync(statPath)) return [3, 2];
                        return [4, fs.readFile(statPath, {
                                encoding: 'utf-8',
                                flag: 'r',
                            })];
                    case 1:
                        status_1 = _b.sent();
                        if (!Number.isNaN(Number(status_1))) {
                            return [2, Number(status_1)];
                        }
                        _b.label = 2;
                    case 2: return [3, 4];
                    case 3: return [2, (_a = SsgCache.cacheStatus[statPath]) !== null && _a !== void 0 ? _a : CacheStatus.MISS];
                    case 4: return [2, CacheStatus.MISS];
                }
            });
        });
    };
    SsgCache.prototype.writeCache = function (keys, data, ttl) {
        return __awaiter(this, void 0, void 0, function () {
            var cachePath, cacheData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cachePath = this.path(keys, 'cache');
                        cacheData = __assign({ data: data }, (typeof ttl === 'number' ? {
                            exp: Date.now() + ttl,
                        } : {}));
                        if (!this.persistent) return [3, 2];
                        return [4, fs.writeFile(cachePath, JSON.stringify(cacheData), {
                                encoding: 'utf-8',
                            })];
                    case 1:
                        _a.sent();
                        return [3, 3];
                    case 2:
                        SsgCache.cache[cachePath] = cacheData;
                        _a.label = 3;
                    case 3: return [2];
                }
            });
        });
    };
    SsgCache.prototype.readCache = function (keys) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var cachePath, data, err_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 6, , 7]);
                        cachePath = this.path(keys, 'cache');
                        if (!this.persistent) return [3, 4];
                        if (!fs.existsSync(cachePath)) return [3, 2];
                        return [4, fs.readFile(cachePath, 'utf-8')];
                    case 1:
                        data = _b.sent();
                        return [2, data ? JSON.parse(data) : null];
                    case 2:
                        this.debugInstance('cache miss %o', keys);
                        _b.label = 3;
                    case 3: return [3, 5];
                    case 4: return [2, (_a = SsgCache.cache[cachePath]) !== null && _a !== void 0 ? _a : null];
                    case 5: return [2, null];
                    case 6:
                        err_1 = _b.sent();
                        this.debugInstance('failed to read cache entry %o, %O', keys, err_1);
                        return [3, 7];
                    case 7: return [2, null];
                }
            });
        });
    };
    SsgCache.prototype.waitForCacheToResolve = function (keys) {
        return __awaiter(this, void 0, void 0, function () {
            var status;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.readCacheStatus(keys)];
                    case 1:
                        status = _a.sent();
                        if (status !== CacheStatus.PENDING) {
                            return [2, status];
                        }
                        return [2, new Promise(function (resolve) {
                                var watchPath = _this.path(keys, 'stat');
                                var listener = function () { return __awaiter(_this, void 0, void 0, function () {
                                    var status;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4, this.readCacheStatus(keys)];
                                            case 1:
                                                status = _a.sent();
                                                if (status !== CacheStatus.PENDING) {
                                                    fs.unwatchFile(watchPath, listener);
                                                    resolve(status);
                                                }
                                                return [2];
                                        }
                                    });
                                }); };
                                fs.watchFile(watchPath, listener);
                            })];
                }
            });
        });
    };
    SsgCache.prototype.wait = function (ms) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, new Promise(function (resolve) {
                        setTimeout(resolve, ms);
                    })];
            });
        });
    };
    SsgCache.prototype.retry = function (fn, maxTimes, ms) {
        if (ms === void 0) { ms = 100; }
        return __awaiter(this, void 0, void 0, function () {
            var retryCount, result, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        retryCount = 0;
                        _a.label = 1;
                    case 1:
                        if (!true) return [3, 7];
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 6]);
                        return [4, fn()];
                    case 3:
                        result = _a.sent();
                        return [2, result];
                    case 4:
                        err_2 = _a.sent();
                        this.debugInstance('try-error: %O', err_2);
                        if (retryCount >= maxTimes) {
                            throw err_2;
                        }
                        return [4, this.wait(ms)];
                    case 5:
                        _a.sent();
                        return [3, 6];
                    case 6: return [3, 1];
                    case 7: return [2];
                }
            });
        });
    };
    SsgCache.prototype.get = function (key, fetcher, options) {
        return __awaiter(this, void 0, void 0, function () {
            var cacheKeys, status_2, value, data, err_3;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cacheKeys = (typeof key === 'string' ? [key] : key);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 9, , 10]);
                        if (!!(options === null || options === void 0 ? void 0 : options.skipCache)) return [3, 4];
                        return [4, this.waitForCacheToResolve(cacheKeys)];
                    case 2:
                        status_2 = _a.sent();
                        return [4, this.readCache(cacheKeys)];
                    case 3:
                        value = _a.sent();
                        if (value
                            && status_2 === CacheStatus.HIT
                            && (typeof (options === null || options === void 0 ? void 0 : options.ttl) !== 'number'
                                || typeof value.exp !== 'number'
                                || Date.now() < value.exp)) {
                            this.debugInstance('cache-hit %s', cacheKeys);
                            return [2, value.data];
                        }
                        _a.label = 4;
                    case 4: return [4, this.writeCacheStatus(cacheKeys, CacheStatus.PENDING)];
                    case 5:
                        _a.sent();
                        this.debugInstance('fetching: %s', cacheKeys);
                        return [4, fetcher()];
                    case 6:
                        data = _a.sent();
                        return [4, this.writeCache(cacheKeys, data, options === null || options === void 0 ? void 0 : options.ttl)];
                    case 7:
                        _a.sent();
                        return [4, this.writeCacheStatus(cacheKeys, CacheStatus.HIT)];
                    case 8:
                        _a.sent();
                        return [2, data];
                    case 9:
                        err_3 = _a.sent();
                        this.debugInstance('get-error: %o, %O', cacheKeys, err_3);
                        return [2, this.retry(function () { return _this.get(key, fetcher, options); }, 5)];
                    case 10: return [2];
                }
            });
        });
    };
    SsgCache.CACHE_DIR = process.env.VERCEL === '1'
        ? path.resolve('/tmp/.next-ssg-cache')
        : path.resolve(process.cwd(), 'node_modules/.cache/next-ssg-cache');
    SsgCache.BUILD_ID_PATH = path.resolve(SsgCache.CACHE_DIR, 'BUILD_ID');
    SsgCache.BUILD_CACHE_PATH = path.resolve(SsgCache.CACHE_DIR, 'cache');
    SsgCache.cache = {};
    SsgCache.cacheStatus = {};
    return SsgCache;
}());
export { SsgCache };
